"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * @Description:sdfsdf
 * @Author: huajian
 * @LastEditors: huajian
 * @LastEditTime: 2021-08-06 17:02:52
 */
var node_fetch_1 = __importDefault(require("node-fetch"));
var fs_1 = __importDefault(require("fs"));
var ejs_1 = __importDefault(require("ejs"));
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var path = require('path');
var outputDir = process.cwd() + '/src/api';
var outputJsonFile = outputDir + '/api-json.json';
if (!fs_1.default.existsSync(outputDir)) {
    fs_1.default.mkdirSync(outputDir);
}
node_fetch_1.default('http://127.0.0.1:7001/api-json')
    .then(function (res) { return res.text(); })
    .then(function (body) {
    fs_1.default.writeFileSync(outputJsonFile, body);
    cross_spawn_1.default.sync('./node_modules/dtsgenerator/bin/dtsgen', [outputJsonFile, '-o', outputDir + '/api-bridge.d.ts'], { stdio: 'inherit' });
    var contentBuf = fs_1.default.readFileSync(outputDir + '/api-bridge.d.ts');
    var content = contentBuf.toString().replace('declare namespace Paths', 'export declare namespace Paths');
    fs_1.default.writeFileSync(outputDir + '/api-bridge.d.ts', content);
    var json = JSON.parse(body);
    var paths = Object.keys(json.paths).map(function (path) {
        var result = json.paths[path];
        result.path = path;
        result.requestSchema = '';
        result.requestRequired = '';
        result.responseSchema = 'any';
        var operationId = result.post.operationId.replace(/_(.)/, function (m, m1) {
            return m1.toUpperCase();
        });
        // 验证是否有有参数
        if (result.post.requestBody) {
            result.requestSchema = 'Paths.' + operationId + '.RequestBody';
            result.requestRequired = result.post.requestBody.required ? '' : '?';
        }
        // 验证返回值
        if (result.post.responses) {
            result.responseSchema = 'Paths.' + operationId + '.Responses.Default';
        }
        return result;
    });
    ejs_1.default.renderFile(path.resolve(__dirname, '../tpl.ejs'), { paths: paths }, function (err, str) {
        if (err) {
            console.log(err);
            return;
        }
        fs_1.default.writeFileSync(outputDir + '/api.ts', str);
    });
});
